import { AptosClient, TxnBuilderTypes, Types } from "aptos";
import { ChainId, ChainName } from "../../utils";
export declare const attestToken: (tokenBridgeAddress: string, tokenChain: ChainId | ChainName, tokenAddress: string) => Types.EntryFunctionPayload;
export declare const completeTransfer: (client: AptosClient, tokenBridgeAddress: string, transferVAA: Uint8Array, feeRecipient: string) => Promise<Types.EntryFunctionPayload>;
export declare const completeTransferAndRegister: (client: AptosClient, tokenBridgeAddress: string, transferVAA: Uint8Array) => Promise<Types.EntryFunctionPayload>;
export declare const completeTransferWithPayload: (_tokenBridgeAddress: string, _tokenChain: ChainId | ChainName, _tokenAddress: string, _vaa: Uint8Array) => Types.EntryFunctionPayload;
export declare const registerCoin: (tokenBridgeAddress: string, originChain: ChainId | ChainName, originAddress: string) => TxnBuilderTypes.TransactionPayloadScript;
export declare const deployCoin: (tokenBridgeAddress: string) => Types.EntryFunctionPayload;
export declare const registerChain: (tokenBridgeAddress: string, vaa: Uint8Array) => Types.EntryFunctionPayload;
export declare const transferTokens: (tokenBridgeAddress: string, fullyQualifiedType: string, amount: string, recipientChain: ChainId | ChainName, recipient: Uint8Array, relayerFee: string, nonce: number, payload?: string) => Types.EntryFunctionPayload;
export declare const createWrappedCoinType: (tokenBridgeAddress: string, vaa: Uint8Array) => Types.EntryFunctionPayload;
export declare const createWrappedCoin: (tokenBridgeAddress: string, attestVAA: Uint8Array) => Types.EntryFunctionPayload;
