import { ChainId } from "../utils";
import { AptosAccount, AptosClient, TxnBuilderTypes, Types } from "aptos";
export declare const signAndSubmitEntryFunction: (client: AptosClient, sender: AptosAccount, payload: Types.EntryFunctionPayload, opts?: Partial<{
    sender: string;
    sequence_number: string;
    max_gas_amount: string;
    gas_unit_price: string;
    expiration_timestamp_secs: string;
    payload: Types.TransactionPayload;
    signature: ({
        type: string;
    } & Types.Ed25519Signature) | ({
        type: string;
    } & {
        sender: ({
            type: string;
        } & Types.Ed25519Signature) | ({
            type: string;
        } & Types.MultiEd25519Signature);
        secondary_signer_addresses: string[];
        secondary_signers: (({
            type: string;
        } & Types.Ed25519Signature) | ({
            type: string;
        } & Types.MultiEd25519Signature))[];
    }) | ({
        type: string;
    } & Types.MultiEd25519Signature);
}> | undefined) => Promise<Types.UserTransaction>;
export declare const signAndSubmitScript: (client: AptosClient, sender: AptosAccount, payload: TxnBuilderTypes.TransactionPayloadScript, opts?: Partial<{
    sender: string;
    sequence_number: string;
    max_gas_amount: string;
    gas_unit_price: string;
    expiration_timestamp_secs: string;
    payload: Types.TransactionPayload;
    signature: ({
        type: string;
    } & Types.Ed25519Signature) | ({
        type: string;
    } & {
        sender: ({
            type: string;
        } & Types.Ed25519Signature) | ({
            type: string;
        } & Types.MultiEd25519Signature);
        secondary_signer_addresses: string[];
        secondary_signers: (({
            type: string;
        } & Types.Ed25519Signature) | ({
            type: string;
        } & Types.MultiEd25519Signature))[];
    }) | ({
        type: string;
    } & Types.MultiEd25519Signature);
}> | undefined) => Promise<Types.Transaction>;
export declare const getAssetFullyQualifiedType: (tokenBridgeAddress: string, originChain: ChainId, originAddress: string) => string | null;
export declare const getForeignAssetAddress: (tokenBridgeAddress: string, originChain: ChainId, originAddress: string) => string | null;
export declare const isValidAptosType: (address: string) => boolean;
export declare const getExternalAddressFromType: (fullyQualifiedType: string) => string;
export declare function getTypeFromExternalAddress(client: AptosClient, tokenBridgeAddress: string, fullyQualifiedTypeHash: string): Promise<string | null>;
